%define ALD_Ver		2.0

Name:         unzip

License:      BSD
Summary:      unzip - list, test and extract compressed files in a ZIP archive
Version:      6.0
Release:      2

#URL: http://www.info-zip.org
URL: http://infozip.sourceforge.net

Source: %{name}60.tar.xz
Source2: %{name}60.2-patches.tgz

%define DestDir		/System
# -----------------------------------------------------

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define _CROSS 0
%define MakeLocCross 0
%define target_ %{nil}
%else
# rpm --target=armv7hl -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 0
%define _build i386-pc-linux-gnu
%define _host %{_arch}-%{_os}%{_gnu}
%define target_ %{_host}-
%endif

#------------------ CROSS DIR --------------------

%define docdir		%{_defaultdocdir}/%{name}

%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{have_auto_local}
%define __os_install_post %{nil}
%define CrossPath	%(%{auto_local} -GetCrossPath -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu})
%endif
# ------------------- description ------------------------------------
%description
unzip - list, test and extract compressed files in a ZIP archive
# -------------------
%package tools
Summary:      unzip-6.0 tools  funzip, unzipsfx, zipgrep
%description tools
unzip-6.0 tools  funzip, unzipsfx, zipgrep

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}60

# patch from Fedora_36 https://fedoraproject.org/ 

tar -xaf %SOURCE2
# Not sent to upstream.
patch -p1<patches/unzip-6.0-bzip2-configure.patch
# Upstream plans to do this in zip (hopefully also in unzip).
patch -p1<patches/unzip-6.0-exec-shield.patch
# Upstream plans to do similar thing.
patch -p1<patches/unzip-6.0-close.patch
# Details in rhbz#532380.
# Reported to upstream: http://www.info-zip.org/board/board.pl?m-1259575993/
patch -p1<patches/unzip-6.0-attribs-overflow.patch
# Not sent to upstream, as it's Fedora/RHEL specific.
# Modify the configure script to accept var LFLAGS2 so linking can be configurable
# from the spec file. In addition '-s' is still removed as before
patch -p1<patches/unzip-6.0-configure.patch
patch -p1<patches/unzip-6.0-manpage-fix.patch
# Update match.c with recmatch() from zip 3.0's util.c
# This also resolves the license issue in that old function.
# Original came from here: https://projects.parabolagnulinux.org/abslibre.git/plain/libre/unzip-libre/match.patch
patch -p1<patches/unzip-6.0-fix-recmatch.patch
# Update process.c
patch -p1<patches/unzip-6.0-symlink.patch
# change using of macro "case_map" by "to_up"
patch -p1<patches/unzip-6.0-caseinsensitive.patch
# downstream fix for "-Werror=format-security"
# upstream doesn't want hear about this option again
patch -p1<patches/unzip-6.0-format-secure.patch

patch -p1<patches/unzip-6.0-valgrind.patch
patch -p1<patches/unzip-6.0-x-option.patch
patch -p1<patches/unzip-6.0-overflow.patch
patch -p1<patches/unzip-6.0-cve-2014-8139.patch
patch -p1<patches/unzip-6.0-cve-2014-8140.patch
patch -p1<patches/unzip-6.0-cve-2014-8141.patch
patch -p1<patches/unzip-6.0-overflow-long-fsize.patch

# Fix heap overflow and infinite loop when invalid input is given (#1260947)
patch -p1<patches/unzip-6.0-heap-overflow-infloop.patch

# support non-{latin,unicode} encoding
patch -p1<patches/unzip-6.0-alt-iconv-utf8.patch
patch -p1<patches/unzip-6.0-alt-iconv-utf8-print.patch
patch -p1<patches/0001-Fix-CVE-2016-9844-rhbz-1404283.patch

# restore unix timestamp accurately
patch -p1<patches/unzip-6.0-timestamp.patch

# fix possible heap based stack overflow in passwd protected files
patch -p1<patches/unzip-6.0-cve-2018-1000035-heap-based-overflow.patch

patch -p1<patches/unzip-6.0-cve-2018-18384.patch

# covscan issues
patch -p1<patches/unzip-6.0-COVSCAN-fix-unterminated-string.patch

patch -p1<patches/unzip-zipbomb-part1.patch
patch -p1<patches/unzip-zipbomb-part2.patch
patch -p1<patches/unzip-zipbomb-part3.patch
patch -p1<patches/unzip-zipbomb-manpage.patch
patch -p1<patches/unzip-zipbomb-part4.patch
patch -p1<patches/unzip-zipbomb-part5.patch
patch -p1<patches/unzip-zipbomb-part6.patch
patch -p1<patches/unzip-zipbomb-switch.patch

sed -i s:"-O3":: unix/configure

# ------------------- Build ------------------------------------------
%Build 
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i586 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -Os -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables -ffunction-sections -fdata-sections"

CFLAGS="$OPTFLAGS -std=gnu99"
LDFLAGS="-Wl,--gc-sections"

make -f unix/Makefile generic CC=%{target_}gcc \
	CF_NOOPT="-I. -DUNIX $CFLAGS -DNOMEMCPY -DIZ_HAVE_UXUIDGID -DNO_LCHMOD" \
	LFLAGS2="$LDFLAGS" \
	&>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make -f unix/Makefile prefix=$RPM_BUILD_ROOT%{_prefix} MANDIR=$RPM_BUILD_ROOT%{_mandir}/man1 INSTALL="cp -p" install
cp -a LICENSE WHERE $RPM_BUILD_ROOT%{docdir}/

pushd $RPM_BUILD_ROOT%{_bindir}
  rm -f zipinfo
  ln -s unzip zipinfo
popd

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -DelLocCrossDir=%{_bindir}
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%files
%{_bindir}/unzip
%{_bindir}/zipinfo
%{_mandir}/man1/unzip.1.gz
%{_mandir}/man1/zipinfo.1.gz
%{docdir}

%files tools
%{_bindir}/funzip
%{_bindir}/unzipsfx
%{_bindir}/zipgrep
%{_mandir}/man1/funzip.1.gz
%{_mandir}/man1/unzipsfx.1.gz
%{_mandir}/man1/zipgrep.1.gz
